/*  dumper - hex, dec, oct dump
 *  Copyright (C) 2005 Dmitri A. Alenitchev
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id$
 *
 */

#include "modes.h"

void
print_hex_dump(int fd, FILE* out, int ascii)
{
  unsigned char buffer[16];
  size_t offset = 0;
  size_t bytes_read;
  int i;

  do {
    bytes_read = read(fd, buffer, sizeof(buffer));

    fprintf(out, "%06x ", offset);

    for (i = 0; i < bytes_read; ++i)
      fprintf(out, "%02x ", buffer[i]);

    if (ascii)
      {
	for (i = 0; i < bytes_read; ++i)
	  if (isascii(buffer[i]) && isprint(buffer[i]))
	    fprintf(out, "%c", buffer[i]);
	  else
	    fprintf(out, " ");
      }
    fprintf(out, "\n");

    offset += bytes_read;
  }
  while (bytes_read == sizeof(buffer));
}
